/*

   QR3Controls.cc - Quick Reports 3 for dBASE

   This file is a library of controls for the QR3 User Interface

   Version - 3.03.0827


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

*/

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3MenuButton(formObj) of Pushbutton(formObj) Custom
 
   with (this)
      onClick = CLASS::onClick  
      height = 20 
      top = 59 
      width = 66 
      text = ""
      fontSize = 9
      fontBold = true
      borderstyle = 2 // Lowered
      mousePointer = 13	// Hand
      colorNormal = "0x404080/0xEBFFFF"
      pageno = 0
      speedbar = true
   endwith

   function onClick                        
      try                                            
         form.pageno := this.TargetPage              
         form.P00_PB_HighlightButton.top := this.top       
         form.P00_PB_HighlightButton.left := this.left     
         form.P00_PB_HighlightButton.width := this.width   
         form.P00_PB_HighlightButton.height := this.height 
         form.P00_PB_HighlightButton.text := this.text
         form.P00_PB_HighlightButton.speedTip := this.speedTip 
         form.LastBasicMenu := this.TargetPage
      catch ( Exception e )                          
         // do nothing - no TargetPage defined 
         // or P00_PB_HighlightButton doesn't exist      
      endtry                                         
   return                                            

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3AdvMenuButton(formObj) of Pushbutton(formObj) Custom
 
   with (this)
      onClick = CLASS::onClick  
      height = 20 
      top = 59 
      width = 84 
      text = ""
      fontSize = 9
      fontBold = true
      borderstyle = 2 // Lowered
      mousePointer = 13	// Hand
      colorNormal = "0x404080/0xEBFFFF"
      pageno = 0
      speedbar = true
      visible = false
   endwith

   function onClick                        
      try                                            
         form.pageno := this.TargetPage              
         form.P00_PB_HighlightButton.top := this.top       
         form.P00_PB_HighlightButton.left := this.left     
         form.P00_PB_HighlightButton.width := this.width   
         form.P00_PB_HighlightButton.height := this.height 
         form.P00_PB_HighlightButton.text := this.text
         form.P00_PB_HighlightButton.speedTip := this.speedTip 
         form.LastAdvancedMenu := this.TargetPage              
      catch ( Exception e )                          
         // do nothing - no TargetPage defined 
         // or P00_PB_HighlightButton doesn't exist      
      endtry                                         
   return                                            

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3StartButton(formObj) of PUSHBUTTON(formObj) Custom 

   with (this)
      height = 20 
      top = 59
      width = 194
      fontSize = 9
      fontBold = true
      mousePointer = 13	// Hand
      borderstyle = 2 // Lowered
      pageno = 0
      colorNormal = "0x404080/0xe1ffff"
   endwith

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3OutputButton(formObj) of PUSHBUTTON(formObj) Custom 

   with (this)
      height = 22 
      width = 30
      top = 373
      mousePointer = 13	// Hand
      borderStyle = 2	// Lowered
      colorNormal = "0x404080/0xEBFFFF"
      text = ''
      speedBar = true
      pageno = 0
   endwith

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3PB(formObj) of PUSHBUTTON(formObj) Custom

   with (this)
      height = 24 
      width = 24 
      fontBold = true
      colorNormal = "BtnText/BtnFace"
   endwith

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

class QR3TXT(formObj) of TEXT(formObj) Custom

   with (this)
      height = 22 
      width = 69 
      colorNormal = "0x4000/0xEBFFFF" 
      fontBold = true
      transparent = false 
   endwith

endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

class QR3TL(formObj) of TEXTLABEL(formObj) Custom

   with (this)
      height = 22 
      width = 69 
      colorNormal = "0x4000/0xEBFFFF" 
      fontBold = true
      transparent = false
   endwith

endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

class QR3_TITLE_TL(formObj) of TEXTLABEL(formObj) Custom

   with (this)
      height = 34
      left = 18
      top = 94
      width = 380
      transparent = true
      colorNormal = "0x4000/0xd6eee5"
      fontSize = 12
      fontBold = true
   endwith

endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3RECT(formObj) of RECTANGLE(formObj) Custom

   with (this)
      width = 10 
      height = 10 
      colorNormal = "0x404080/0xEBFFFF" // "maroon/0xd6eee5"
      fontBold = true
   endwith

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

Class QR3CHB(formObj) of CHECKBOX(formObj) Custom

   with (this)
      width = 10 
      height = 24 
      colorNormal = "0x4000/0xEBFFFF" // "0x4000/0xd6eee5"
      fontBold = true
   endwith

Endclass

//--------------------------------------------------------------------
//--------------------------------------------------------------------
//--------------------------------------------------------------------

class QR3RB(formObj) of RADIOBUTTON(formObj) Custom

   with (this)
      width = 10 
      height = 22 
      colorNormal = "0x4000/0xEBFFFF" // "0x4000/0xd6eee5"
      fontBold = true
   endwith

endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class QR3CB(parentObj) of COMBOBOX(parentObj) custom

   with (this)
      height = 22
      style = 2   // DropDownList
   endwith
 
endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class QR3TablePicker(parentObj) of CONTAINER(parentObj) custom

   /*

   QR3TablePicker.cc - Version 3.03.0827

   A Table Picker control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      width = 225
      height = 221
      metric = 6	// Pixels
      borderStyle = 9	// Etched In
   endwith

   // Custom Properties
   this.oQR3Ref = null        // A reference to the QR3 object

   this.LB = new LISTBOX(this)
   with (this.LB)
      onLeftDblClick = class::SetTable
      key = class::TP_Key
      height = 157
      left = 10
      top = 30
      width = 200
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the tooltip to work !!
      speedTip = "Select Data Table from list"
      helpId = "#30"
   endwith

   this.RECT_TOP_BACK = new RECTANGLE(this)
   with (this.RECT_TOP_BACK)
      left = 10
      top = 10
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF = new ENTRYFIELD(this)
   with (this.EF)
      height = 16
      left = 13
      top = 13
      width = 179
      border = false
      fontBold = true
      value = ""
      borderStyle = 3	// None
      speedTip = "Current Data Table"
      when = {||false}
   endwith

   this.PB_INFO = new PUSHBUTTON(this)
   with (this.PB_INFO)
      height = 16
      left = 193
      top = 13
      width = 15
      text = ""
      speedbar = true
   endwith

   this.RECT_PACKER = new RECTANGLE(this)
   with (this.RECT_PACKER)
      left = 193
      top = 13
      width = 14
      height = 15
      text = ""
      border = false
      pageno = 0
      borderStyle = 1	// Raised
   endwith

   this.RECT_BOT_BACK = new RECTANGLE(this)
   with (this.RECT_BOT_BACK)
      left = 10
      top = 186
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_SELECT = new PUSHBUTTON(this)
   with (this.PB_SELECT)
      onClick = class::SetTable
      height = 18
      left = 12
      top = 188
      width = 196
      text = "Select"
      fontSize = 9
      fontBold = true
      speedTip = "Select highlighted Table for report"
      speedbar = true
   endwith

   // -------------------------------------

   function InitialiseTP(oQR3Ref)

      // Give this control access to the outside world
      this.oQR3Ref = oQR3Ref

      if not this.oQR3Ref == null

         // Link into the QR3 Table List
         this.LB.datasource := "Array this.oQR3Ref.aTableList"

         // Update Display
         if len(this.oQR3Ref.FullTableName) < 1
            this.EF.value := "No Table Selected"
         else
            this.EF.value := this.oQR3Ref.FullTableName
         endif

         // Position Listbox Cursel
         nPos = this.oQR3Ref.aTableList.scan(this.oQR3Ref.FullTableName)
         if nPos > 0
            this.LB.cursel := 1
            this.LB.cursel := nPos
            this.LB.cursel := nPos + 4
            this.LB.cursel := iif(nPos < 5, 1, nPos - 4)
            this.LB.cursel := nPos
         else
            this.LB.cursel := 1
         endif

      endif

      return

   // -------------------------------------

   function SetColoursTP(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         this.LB.ColorNormal := cListCol
      endif
      if not empty(argvector(3))
         this.LB.ColorHighlight := cListHigh
      endif
      if not empty(argvector(5))
      endif
      if not empty(argvector(6))
         this.PB_Info.ColorNormal := cButCol
         this.PB_Select.ColorNormal := cButCol
      endif

      return

   // -------------------------------------

   function SetTable(flags, col, row)

      // Set the selected table
      if not this.parent.oQR3Ref.SetTable(this.parent.LB.value)     
         // Any error dialogue will be done by QR3     
         return                                
      endif                                    

      // Update display
      this.parent.EF.value := this.parent.oQR3Ref.FullTableName
         
   return

   // -------------------------------------

   function TP_Key(nChar, nPosition,bShift,bControl)
      if nChar == 13 // Enter
         this.parent.PB_SELECT.onClick()
      endif
   return   

   // -------------------------------------

endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class QR3IndexPicker(parentObj) of CONTAINER(parentObj) custom

   /*

   QR3IndexPicker.cc - Version 3.03.0827

   An Index Picker control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      width = 225
      height = 221
      metric = 6	// Pixels
      borderStyle = 9	// Etched In
   endwith

   // Custom Properties
   this.oQR3Ref = null        // A reference to the QR3 object

   this.LB = new LISTBOX(this)
   with (this.LB)
      onLeftDblClick = class::SetIndex
      onRightMouseUp = class::ShowIndexExpression
      key = class::IP_Key
      height = 157
      left = 10
      top = 30
      width = 200
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the tooltip to work !!
      speedTip = "Right Click for Index Information"
      helpId = "#50"
   endwith

   this.RECT_TOP_BACK = new RECTANGLE(this)
   with (this.RECT_TOP_BACK)
      left = 10
      top = 10
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF = new ENTRYFIELD(this)
   with (this.EF)
      height = 16
      left = 13
      top = 13
      width = 179
      border = false
      fontBold = true
      value = ""
      borderStyle = 3	// None
      speedTip = "Current Index Order"
      when = {||false}
   endwith

   this.RECT_PACKER = new RECTANGLE(this)
   with (this.RECT_PACKER)
      left = 193
      top = 13
      width = 14
      height = 15
      text = ""
      border = false
      pageno = 0
      borderStyle = 1	// Raised
   endwith

   this.PB_CLEAR = new PUSHBUTTON(this)
   with (this.PB_CLEAR)
      onClick = class::ClearIndex
      height = 16
      left = 193
      top = 13
      width = 15
      text = ""
      upBitmap = "RESOURCE #2240"
      speedbar = true
      speedTip = "Restore Natural Order"
   endwith

   this.RECT_BOT_BACK = new RECTANGLE(this)
   with (this.RECT_BOT_BACK)
      left = 10
      top = 186
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_SELECT = new PUSHBUTTON(this)
   with (this.PB_SELECT)
      onClick = class::SetIndex
      height = 18
      left = 12
      top = 188
      width = 196
      text = "Select"
      fontSize = 9
      fontBold = true
      speedTip = "Select highlighted Index Order for report"
      speedbar = true
   endwith

   // -------------------------------------

   function InitialiseIP(oQR3Ref)

      // Give this control access to the outside world
      this.oQR3Ref = oQR3Ref

      if not this.oQR3Ref == null

         // Build Index List
         toi = this.oQR3Ref.oTableDef.indexes
         this.aIndexList = new Array(toi.size)
         for nCount = 1 to toi.size
            this.aIndexList[nCount] = toi[nCount].indexname
         endfor //next

         // Update DataSource
         this.LB.datasource := "Array this.aIndexList"
         
         // Update Display
         if len(this.oQR3Ref.IndexName) < 1
            this.EF.value := "No Index Order Selected"
         else
            this.EF.value := this.oQR3Ref.IndexName
         endif

         // Position Listbox Cursel
         nPos = this.aIndexList.scan(this.oQR3Ref.IndexName)
         if nPos > 0
            this.LB.cursel := 1
            this.LB.cursel := nPos
            this.LB.cursel := nPos + 4
            this.LB.cursel := iif(nPos < 5, 1, nPos - 4)
            this.LB.cursel := nPos
         else
            this.LB.cursel := 1
         endif

      endif

      return

   // -------------------------------------

   function SetColoursIP(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         this.LB.ColorNormal := cListCol
      endif
      if not empty(argvector(3))
         this.LB.ColorHighlight := cListHigh
      endif
      if not empty(argvector(5))
      endif
      if not empty(argvector(6))
         this.PB_Info.ColorNormal := cButCol
         this.PB_Select.ColorNormal := cButCol
      endif

      return

   // -------------------------------------

   function SetIndex(flags, col, row)

      // Set the selected Index
      if not this.parent.oQR3Ref.SetIndex(this.parent.LB.value)     
         // Any error dialogue will be done by QR3     
         return                                
      endif                                    

      // Update display
      this.parent.EF.value := this.parent.oQR3Ref.IndexName
         
   return

   // -------------------------------------

   function ClearIndex()

      // Set the selected Index
      if not this.parent.oQR3Ref.SetIndex()     
         // Any error dialogue will be done by QR3     
         return                                
      endif                                    

      // Update display
      this.parent.EF.value := "No Index Selected"

   return

   // -------------------------------------

   function ShowIndexExpression()

      cText = "Table Name = " + this.parent.oQR3Ref.FullTableName + chr(13) + chr(13) ; 
            + "Index Name = " + this.value + chr(13) + chr(13) ; 
            + "Index Expression = " + this.parent.oQR3Ref.oTableDef.indexes[this.value].expression

      msgbox(cText," Index Information",64)
   
   return

   // -------------------------------------

   function IP_Key(nChar, nPosition,bShift,bControl)
      if nChar == 13 // Enter
         this.parent.PB_SELECT.onClick()
      endif
   return   

   // -------------------------------------

endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class QR3RangeBuilder(parentObj) of CONTAINER(parentObj) custom

   /*

   QR3RangeBuilder.cc - Version 3.03.0827

   A Range Builder control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      left = 10
      top = 10
      width = 225
      height = 218
      metric = 6	// Pixels
      borderStyle = 9	// Etched In
   endwith

   // Custom Properties
   this.oQR3Ref = null        // A reference to the QR3 object

   this.RECT_SELECTED_RANGE = new RECTANGLE(this)
   with (this.RECT_SELECTED_RANGE)
      left = 10
      top = 10
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF_SELECTED_RANGE = new ENTRYFIELD(this)
   with (this.EF_SELECTED_RANGE)
      when = {|| false}
      height = 16
      left = 13
      top = 13
      width = 179
      border = false
      fontName = "Arial"
      fontSize = 10
      fontBold = true
      value = ""
      borderStyle = 3	// None
      speedTip = "Current Range Setting"
   endwith

   this.PB_SELECTED_RANGE = new PUSHBUTTON(this)
   with (this.PB_SELECTED_RANGE)
      onClick = {; this.parent.oQR3Ref.SetRange(); this.parent.InitialiseRB()}
      height = 16
      left = 193
      top = 13
      width = 15
      text = ""
      speedBar = true
      upBitmap = "RESOURCE #2240"
      speedTip = "Clear Range"
   endwith

   this.RECT_INFO = new RECTANGLE(this)
   with (this.RECT_INFO)
      left = 10
      top = 30
      width = 200
      height = 74
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.TL_RANGE_FIELD_INFO = new TEXTLABEL(this)
   with (this.TL_RANGE_FIELD_INFO)
      height = 18
      left = 12
      top = 38
      width = 196
      fontName = "Arial"
      fontSize = 10
      text = "Range Field Information :"
      alignHorizontal = 1	// Center
   endwith

   this.TL_RANGE_FIELD_NAME = new TEXTLABEL(this)
   with (this.TL_RANGE_FIELD_NAME)
      height = 18
      left = 12
      top = 59
      width = 196
      fontName = "Arial"
      fontSize = 10
      text = "Name :"
      alignHorizontal = 1	// Center
   endwith

   this.TL_RANGE_FIELD_TYPE = new TEXTLABEL(this)
   with (this.TL_RANGE_FIELD_TYPE)
      height = 18
      left = 12
      top = 80
      width = 196
      fontName = "Arial"
      fontSize = 10
      text = "Type :"
      alignHorizontal = 1	// Center
   endwith

   this.RECT_FROM_BACK = new RECTANGLE(this)
   with (this.RECT_FROM_BACK)
      left = 10
      top = 103
      width = 200
      height = 21
      fontName = "Arial"
      fontSize = 10
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.TXT_FROM = new TEXT(this)
   with (this.TXT_FROM)
      height = 14
      left = 14
      top = 106
      width = 100
      fontName = "Arial"
      fontSize = 9
      text = " From :"
      borderStyle = 3	// None
   endwith

   this.RECT_RANGE1 = new RECTANGLE(this)
   with (this.RECT_RANGE1)
      left = 10
      top = 122
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF_RANGE1 = new ENTRYFIELD(this)
   with (this.EF_RANGE1)
      onGotFocus = {; this.Last = true; this.parent.EF_Range2.Last = false}
      onChange = {; this.parent.SetRange()}
      height = 16
      left = 13
      top = 125
      width = 179
      border = false
      fontName = "Arial"
      fontSize = 10
      value = ""
      borderStyle = 3	// None
      speedTip = "Include data from this entry"
      helpId = "#60"
   endwith

   this.PB_RANGE1 = new PUSHBUTTON(this)
   with (this.PB_RANGE1)
      onClick = {; this.parent.EF_RANGE1.value := null; this.parent.SetRange()}
      height = 17
      left = 193
      top = 124
      width = 15
      text = ""
      speedBar = true
      upBitmap = "RESOURCE #2240"
      speedTip = "Clear this Range entry"
   endwith

   this.RECT_TO_BACK = new RECTANGLE(this)
   with (this.RECT_TO_BACK)
      left = 10
      top = 143
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.TXT_TO = new TEXT(this)
   with (this.TXT_TO)
      height = 14
      left = 14
      top = 146
      width = 100
      fontName = "Arial"
      fontSize = 9
      text = " To :"
      borderStyle = 3	// None
   endwith

   this.RECT_RANGE2 = new RECTANGLE(this)
   with (this.RECT_RANGE2)
      left = 10
      top = 162
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF_RANGE2 = new ENTRYFIELD(this)
   with (this.EF_RANGE2)
      onGotFocus = {; this.Last = true; this.parent.EF_Range1.Last = false}
      onChange = {; this.parent.SetRange()}
      height = 16
      left = 13
      top = 165
      width = 179
      border = false
      fontName = "Arial"
      fontSize = 10
      value = ""
      borderStyle = 3	// None
      speedTip = "Include data to this entry"
      helpId = "#60"
   endwith

   this.PB_RANGE2 = new PUSHBUTTON(this)
   with (this.PB_RANGE2)
      onClick = {; this.parent.EF_RANGE2.value := null; this.parent.SetRange()}
      height = 17
      left = 193
      top = 164
      width = 15
      text = ""
      speedBar = true
      upBitmap = "RESOURCE #2240"
      speedTip = "Clear this Range entry"
   endwith

   this.RECT_COPY_OK_BACK = new RECTANGLE(this)
   with (this.RECT_COPY_OK_BACK)
      left = 10
      top = 183
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_COPY = new PUSHBUTTON(this)
   with (this.PB_COPY)
      onClick = {; this.parent.CopyRange()}
      height = 18
      left = 12
      top = 185
      width = 98
      text = "Copy"
      speedBar = true
      fontSize = 9
      speedTip = "Duplicate Range Entry"
   endwith

   this.PB_OK = new PUSHBUTTON(this)
   with (this.PB_OK)
      onClick = {; this.parent.SetRange()}
      height = 18
      left = 110
      top = 185
      width = 98
      text = "OK"
      speedBar = true
      fontSize = 9
      speedTip = "Set Selected Range"
   endwith

   // -------------------------------------

   function InitialiseRB(oQR3Ref)

      // Give this control access to the outside world
      if not empty(argvector(1))
         this.oQR3Ref = oQR3Ref
      endif

      if not this.oQR3Ref == null

         // Ensure Range Display Text fits - and update
         if len(this.oQR3Ref.RangeDisplayString) < 24
            this.EF_Selected_Range.fontSize := 10
         else
            this.EF_Selected_Range.fontSize := 10 * (24 / len(this.oQR3Ref.RangeDisplayString))
         endif
         if this.oQR3Ref.Range1 == null and this.oQR3Ref.Range2 == null
            this.EF_Selected_Range.value := "No Range Set"
         else
            this.EF_Selected_Range.value := this.oQR3Ref.RangeDisplayString
         endif

         // Range Field Info
         if len(this.oQR3Ref.IndexName) < 1
            this.TL_Range_Field_Name.text := "Name :  Undefined" 
            this.TL_Range_Field_Type.text := "Type :  Undefined" 
         else
            this.TL_Range_Field_Name.text := "Name :  " + this.oQR3Ref.IndexField
            this.TL_Range_Field_Type.text := "Type :  " + this.oQR3Ref.oTableDef.fields[this.oQR3Ref.IndexField].type
         endif

         // Range Entryfields
         this.EF_Range1.picture := null
         this.EF_Range2.picture := null

         do case

            //Char type                                      
            case this.oQR3Ref.IndexType = 'C'  // char type     
               this.EF_Range1.value := ''
               this.EF_Range2.value := ''
       
            // Date type                                    
            case this.oQR3Ref.IndexType = 'D'  // date type     
               this.EF_Range1.value := {}
               this.EF_Range2.value := {}
       
            // Numeric type                                     
            case this.oQR3Ref.IndexType = 'N'  // numeric type       
               // If numeric we need to format and right justify
               nLen = this.oQR3Ref.IndexFieldLength                   
               nDec = this.oQR3Ref.IndexFieldDecimals                 
       
               // Build format string 
       
               if nDec < 1                                                           
                  cFormat = Replicate('9',nLen)                                      
               else                                                                  
                  cFormat = Replicate('9',(nLen-(nDec+1)))+'.'+Replicate('9',nDec)   
               endif                                                                 
       
               // This sequence is needed to set up the EntryFields for
               // numeric entry, set the picture, and then blank the contents 
               this.EF_Range1.value := 0
               this.EF_Range2.value := 0
               this.EF_Range1.picture := cFormat
               this.EF_Range2.picture := cFormat
               this.EF_Range1.value := null
               this.EF_Range2.value := null

         endcase

         this.EF_Range1.value := form.QR3.Range1
         this.EF_Range2.value := form.QR3.Range2 

      endif

      return

   // -------------------------------------

   function SetColoursRB(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         //
      endif
      if not empty(argvector(3))
         this.RECT_Info.ColorNormal := cListHigh
         this.TL_RANGE_FIELD_INFO.ColorNormal := cListHigh
         this.TL_RANGE_FIELD_NAME.ColorNormal := cListHigh
         this.TL_RANGE_FIELD_TYPE.ColorNormal := cListHigh
      endif
      if not empty(argvector(5))

      endif
      if not empty(argvector(6))
         this.PB_Copy.ColorNormal := cButCol
         this.PB_OK.ColorNormal := cButCol
      endif

   return

   // -------------------------------------

   function CopyRange()

      if this.EF_Range1.Last == true and not empty(this.EF_Range1.value)
         this.EF_Range2.value := this.EF_Range1.value
         this.EF_Range2.setFocus()
      elseif this.EF_Range2.Last == true and not empty(this.EF_Range2.value)
         this.EF_Range1.value := this.EF_Range2.value
         this.EF_Range1.setFocus()
      elseif not empty(this.EF_Range1.value)
         this.EF_Range2.value := this.EF_Range1.value
         this.EF_Range2.setFocus()
      elseif not empty(this.EF_Range2.value)
         this.EF_Range1.value := this.EF_Range2.value
         this.EF_Range1.setFocus()
      endif

      this.SetRange()

   return

   // -------------------------------------

   function SetRange()

      // Set QR3 Range
      r1 = iif(empty(this.EF_Range1.value), null, this.EF_Range1.value)
      r2 = iif(empty(this.EF_Range2.value), null, this.EF_Range2.value)
      this.oQR3Ref.SetRange(r1,r2) 
         
      // Update display 
      this.InitialiseRB()

   return

   // -------------------------------------

endclass


// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

Class QR3FieldPicker(formObj) of CONTAINER(formObj) Custom

   /*

   QR3FieldPicker.cc - Version 3.03.0827

   A Field Picker control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      width = 435
      height = 218
      metric = 6  // Pixels
      borderStyle = 9   // Etched In
      parent.metric := 6 // Pixels
   endwith

   // Custom Properties
   this.oQR3Ref = null        // A reference to the QR3 object
   this.oUIRef = null         // A reference to the User interface
   this.cUpdateCommand = null // A command string with which to update the UI

   //
    
   this.LB_SOURCE = new LISTBOX(this)
   with (this.LB_SOURCE)
      onLeftDblClick = {; this.parent.AddOne()}
      onRightMouseUp = class::ShowFieldInfo
      key = class::FP_Key
      height = 174
      left = 10
      top = 10
      width = 200
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the speedtip to work !!
      speedTip = "List of fields available for report - Right Click for Field Information"
      multiple = false
      cursel = 0
      helpId = "#40"
   endwith

   this.RECT_SOURCE_BACK = new RECTANGLE(this)
   with (this.RECT_SOURCE_BACK)
      left = 10
      top = 183
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_ADD_ONE = new PUSHBUTTON(this)
   with (this.PB_ADD_ONE)
      onClick = {; this.parent.AddOne()}
      height = 18
      left = 12
      top = 185
      width = 98
      text = ">"
      fontSize = 9
      fontBold = true
      speedBar = true
      speedTip = "Select highlighted field for report"
   endwith

   this.PB_ADD_ALL = new PUSHBUTTON(this)
   with (this.PB_ADD_ALL)
      onClick = {; this.parent.AddAll()}
      height = 18
      left = 110
      top = 185
      width = 98
      text = ">>"
      fontSize = 9
      fontBold = true
      speedBar = true
      speedTip = "Select all fields for report"
   endwith

   this.LB_DEST = new LISTBOX(this)
   with (this.LB_DEST)
      onLeftDblClick = {; this.parent.RemoveOne()}
      onRightMouseUp = class::ShowFieldInfo
      key = class::FP_Key
      height = 174
      left = 220
      top = 10
      width = 200
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the speedtip to work !!
      speedTip = "List of fields included in report - Right Click for Field Information"
      multiple = false
      cursel = 0
      helpId = "#40"
   endwith

   this.RECT_DEST = new RECTANGLE(this)
   with (this.RECT_DEST)
      left = 220
      top = 183
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_MOVE_UP = new PUSHBUTTON(this)
   with (this.PB_MOVE_UP)
      onClick = {; this.parent.MoveUp()}
      height = 18
      left = 222
      top = 185
      width = 49
      text = "Up"
      fontSize = 8
      speedBar = true
      speedTip = "Move highlighted field up"
   endwith

   this.PB_MOVE_DOWN = new PUSHBUTTON(this)
   with (this.PB_MOVE_DOWN)
      onClick = {; this.parent.MoveDown()}
      height = 18
      left = 271
      top = 185
      width = 49
      text = "Down"
      fontSize = 8
      speedBar = true
      speedTip = "Move highlighted field down"
   endwith

   this.PB_REMOVE_ONE = new PUSHBUTTON(this)
   with (this.PB_REMOVE_ONE)
      onClick = {; this.parent.RemoveOne()}
      height = 18
      left = 320
      top = 185
      width = 49
      text = "Clear"
      fontSize = 8
      speedBar = true
      speedTip = "Remove highlighted field from report"
   endwith

   this.PB_REMOVE_ALL = new PUSHBUTTON(this)
   with (this.PB_REMOVE_ALL)
      onClick = {; this.parent.RemoveAll()}
      height = 18
      left = 369
      top = 185
      width = 49
      text = "Clear All"
      fontSize = 8
      speedBar = true
      speedTip = "Remove all fields from report"
   endwith


   // -------------------------------------
                        

   function Initialise(oQR3Ref, oUIRef, cUpdateCommand)

      // Give this control access to the outside world
      this.oQR3Ref = oQR3Ref
      this.oUIRef = oUIRef
      this.cUpdateCommand = cUpdateCommand

      // Keep a copy of the original fields within the control
      this.aStartList = new Array()
      this.aStartList.resize(this.oQR3Ref.aTableFieldList.size)
      ACOPY(this.oQR3Ref.aTableFieldList,this.aStartList)
      
      // New Source Array
      this.aSource = new Array()
      this.aSource.resize(this.oQR3Ref.aTableFieldList.size)
      ACOPY(this.oQR3Ref.aTableFieldList,this.aSource)

      // Remove from Source array any fields already chosen
      for nCount = 1 to this.oQR3Ref.aChosenFieldList.size
         for nCount2 = 1 to this.aSource.size
            if this.oQR3Ref.aChosenFieldList[nCount] == this.aSource[nCount2]
               // Delete Source entry
               this.aSource.delete(nCount2)
               // Re-size Source array
               if this.aSource.size = 1
                  this.aSource = new Array()
               else
                  this.aSource.resize(this.aSource.size - 1)
               endif
               // Exit loop 
               exit
            endif
         endfor // next
      endfor // next
      this.LB_Source.datasource := "Array this.aSource"

      // New Destination Array
      this.aDest = new Array()
      if this.oQR3Ref.aChosenFieldList.size > 0
         this.aDest.resize(this.oQR3Ref.aChosenFieldList.size)
         ACOPY(this.oQR3Ref.aChosenFieldList,this.aDest)
      endif
      this.LB_Dest.datasource := "Array this.aDest" 

      // Ensure first entries highlighted
      this.LB_Source.curSel = 1
      this.LB_Dest.curSel = 1

      // Update External controls
      this.UpdateExternals()

      return true


   // -------------------------------------


   function SetColours(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         this.LB_SOURCE.ColorNormal := cListCol
         this.LB_DEST.ColorNormal := cListCol
      endif
      if not empty(argvector(3))
         this.LB_SOURCE.ColorHighlight := cListHigh
         this.LB_DEST.ColorHighLight := cListHigh
      endif
      if not empty(argvector(5))
      endif
      if not empty(argvector(6))
         this.PB_ADD_ONE.ColorNormal := cButCol
         this.PB_ADD_ALL.ColorNormal := cButCol
         this.PB_MOVE_UP.ColorNormal := cButCol
         this.PB_MOVE_DOWN.ColorNormal := cButCol
         this.PB_REMOVE_ONE.ColorNormal := cButCol
         this.PB_REMOVE_ALL.ColorNormal := cButCol
      endif

      return


   // -------------------------------------
    

   function AddOne()

      // Move the selected entry in Source listbox
      // to Destination listbox
      
      // Check there are entries to move first
      if this.aSource.size < 1
         return
      endif
      
      // Get position of selected entry
      local nPosition
      nPosition = this.LB_Source.curSel
       
      // Add to Destination listbox array
      this.aDest.add(this.aSource[nPosition])
      
      // Delete Source entry
      this.aSource.delete(nPosition)
      
      // Re-size Source array
      if this.aSource.size = 1
         this.aSource = new Array()
      else
         this.aSource.resize(this.aSource.size - 1)
      endif
      
      // Update Listbox display
      this.LB_Source.dataSource := this.LB_Source.dataSource
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
      // Ensure appropriate entries highlighted
      if nPosition > this.aSource.size
         this.LB_SOURCE.curSel := nPosition - 1
      else
         this.LB_SOURCE.curSel := nPosition
      endif
      this.LB_DEST.curSel := this.aDest.size
      
      // Update External controls
      this.UpdateExternals()
      
   return


   // -------------------------------------



   function AddAll()
      
      // Move all entries in Source listbox to Destination listbox
      
      // Check there are fields to move first
      if this.aStartList.size < 1
         return
      endif
      
      this.aDest = (this.aStartList)
      this.aSource = new Array()
      
      // Update Listbox display
      this.LB_Source.dataSource := this.LB_Source.dataSource
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
      // Ensure first entry highlighted
      this.LB_SOURCE.curSel := 1
      this.LB_DEST.curSel := 1
      
      // Update External controls
      this.UpdateExternals()

   return


   // -------------------------------------


   function RemoveOne()

      // Move the selected entry in Destination listbox
      // to Source listbox

      // Check there are entries to move first
      if this.aDest.size < 1
         return
      endif

      // Deal with this being a Calculated Field
      if this.oQR3Ref.aaCalcFields.iskey(this.LB_DEST.value)

         cText = "This is a calculated field." + chr(13) + chr(13);
               + "Removing this field will mean that it is " + chr(13);
               + "no longer available, and will, if required, "  + chr(13);
               + "have to be re-created from scratch."  + chr(13) + chr(13);
               + "Do you wish to proceed ?"

         nResponse = msgbox(cText,"Remove Calculated Field",32+4)

         if nResponse == 6 // Yes

            this.oQR3Ref.DeleteCalcField(this.LB_DEST.value)

            // Delete Destination entry
            this.aDest.delete(this.LB_Dest.curSel)
      
            // Re-size Destination array
            if this.aDest.size = 1
               this.aDest = new Array()
            else
               this.aDest.resize(this.aDest.size - 1)
            endif
      
            // Update Listbox display
            this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
            // Ensure appropriate entries highlighted
            if this.LB_Dest.curSel > this.aDest.size
               this.LB_DEST.curSel := nDestPosition - 1
            else
               this.LB_DEST.curSel := this.LB_Dest.curSel
            endif
      
            // Update External controls
            this.UpdateExternals()

         endif

         return

      endif

      // Deal with this being a MemoText Field
      if this.oQR3Ref.aaMemoTextFields.iskey(this.LB_DEST.value)

         cText = "This is a MemoText field." + chr(13) + chr(13);
               + "Removing this field will mean that it is " + chr(13);
               + "no longer available, and will, if required, "  + chr(13);
               + "have to be re-created from scratch."  + chr(13) + chr(13);
               + "Do you wish to proceed ?"

         nResponse = msgbox(cText,"Remove MemoText Field",32+4)

         if nResponse == 6 // Yes

            this.oQR3Ref.DeleteMemoTextField(this.LB_DEST.value)

            // Delete Destination entry
            this.aDest.delete(this.LB_Dest.curSel)
      
            // Re-size Destination array
            if this.aDest.size = 1
               this.aDest = new Array()
            else
               this.aDest.resize(this.aDest.size - 1)
            endif
      
            // Update Listbox display
            this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
            // Ensure appropriate entries highlighted
            if this.LB_Dest.curSel > this.aDest.size
               this.LB_DEST.curSel := nDestPosition - 1
            else
               this.LB_DEST.curSel := this.LB_Dest.curSel
            endif
      
            // Update External controls
            this.UpdateExternals()

         endif

         return

      endif
      
      // Get position of selected entry
      local nSourcePosition, nDestPosition
      nSourcePosition = this.LB_Source.curSel
      if nSourcePosition = 0
         nSourcePosition = 1
      endif
      nDestPosition = this.LB_Dest.curSel
       
      // Insert a location
      this.aSource.grow( 1 )
      this.aSource.insert(nSourcePosition)

      // Move to Source listbox array
      this.aSource[nSourcePosition] = this.aDest[nDestPosition]
      
      // Delete Destination entry
      this.aDest.delete(nDestPosition)
      
      // Re-size Destination array
      if this.aDest.size = 1
         this.aDest = new Array()
      else
         this.aDest.resize(this.aDest.size - 1)
      endif
      
      // Update Listbox display
      this.LB_Source.dataSource := this.LB_Source.dataSource
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
      // Ensure appropriate entries highlighted
      this.LB_SOURCE.curSel := nSourcePosition

      if nDestPosition > this.aDest.size
         this.LB_DEST.curSel := nDestPosition - 1
      else
         this.LB_DEST.curSel := nDestPosition
      endif
      
      // Update External controls
      this.UpdateExternals()

   return


   // -------------------------------------


   function RemoveAll()

      // Deal with Calculated Fields
      if this.oQR3Ref.aaCalcFields.count() > 0

         cText = "There are calculated fields." + chr(13) + chr(13);
               + "Removing these fields will mean that they are " + chr(13);
               + "no longer available, and will, if required, "  + chr(13);
               + "have to be re-created from scratch."  + chr(13) + chr(13);
               + "Do you wish to proceed ?"

         nResponse = msgbox(cText,"Remove Calculated Fields",32+4)

         if nResponse == 6 // Yes
            for nCount = 1 to this.oQR3Ref.aaCalcFields.count()
               this.oQR3Ref.DeleteCalcField(this.oQR3Ref.aaCalcFields.firstKey)
            endfor // next
         else
            return
         endif

      endif

      // Deal with MemoText Fields
      if this.oQR3Ref.aaMemoTextFields.count() > 0

         cText = "There are MemoText fields." + chr(13) + chr(13);
               + "Removing these fields will mean that they are " + chr(13);
               + "no longer available, and will, if required, "  + chr(13);
               + "have to be re-created from scratch."  + chr(13) + chr(13);
               + "Do you wish to proceed ?"

         nResponse = msgbox(cText,"Remove MemoText Fields",32+4)

         if nResponse == 6 // Yes
            for nCount = 1 to this.oQR3Ref.aaMemoTextFields.count()
               this.oQR3Ref.DeleteMemoTextField(this.oQR3Ref.aaMemoTextFields.firstKey)
            endfor // next
         else
            return
         endif

      endif

      // Initialise Destination and Source listbox arrays
      this.aSource = (this.aStartList)
      this.aDest = new Array()
      
      // Update Listbox display
      this.LB_Source.dataSource := this.LB_Source.dataSource
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      
      // Ensure first entry highlighted
      this.LB_SOURCE.curSel := 1
      this.LB_DEST.curSel := 1
       
      // Update External controls
      this.UpdateExternals()

   return


   // -------------------------------------


   function MoveUp()

      // Move an entry up Destination listbox array

      // Check there are entries to move first      
      if this.aDest.size < 2
        return
      endif
      
      local nPosition, cTemp

      nPosition = this.LB_Dest.curSel
      
      if nPosition == 1
         return // Can't move first entry up
      endif
         
      // Do the move
      cTemp = this.aDest[nPosition - 1]
      this.aDest[nPosition - 1] := this.aDest[nPosition]
      this.aDest[nPosition] := cTemp

      // Update Listbox display
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      this.LB_Dest.curSel --

      // Update External controls
      this.UpdateExternals()

   return


   // -------------------------------------

   
   function MoveDown()

      // Move entry down Destination listbox array
      
      // Check there are entries to move first  
      if this.aDest.size = 0 
        return
      endif
        
      local nPosition, cTemp
        
      nPosition = this.LB_Dest.curSel
        
      if nPosition == this.aDest.size
         return // Can't move last entry down
      endif
      
      // Do the move
      cTemp = this.aDest[nPosition + 1]
      this.aDest[nPosition + 1] := this.aDest[nPosition]
      this.aDest[nPosition] := cTemp
      
      // Update Listbox display
      this.LB_Dest.dataSource := this.LB_Dest.dataSource
      this.LB_Dest.curSel ++

      // Update External controls
      this.UpdateExternals()
      
      return


   // -------------------------------------

   function ShowFieldInfo()

      try
         cText = "Field Name = " + this.value + chr(13) ;
               + "Field Type = " + this.parent.oQR3Ref.oTableDef.fields[this.value].type  + chr(13) ;
               + "Field Length = " + this.parent.oQR3Ref.oTableDef.fields[this.value].length
         if this.parent.oQR3Ref.oTableDef.fields[this.value].type == "NUMERIC"
            cText = cText + chr(13) ;
                  + "Field Decimal Length = " + this.parent.oQR3Ref.oTableDef.fields[this.value].decimalLength
         endif
      catch (exception e)
         cText = "Field Name = " + this.value + chr(13) ;
               + "Field Type = Virtual Field"
      endtry

      msgbox(cText," Field Information",64)

   return

   // -------------------------------------

   function UpdateExternals()

      // Update QR3 control
      this.oQR3Ref.SetChosenFields((this.aDest))

      // Update UI by object ref and command
      private sMacroString
      sMacroString = "this.oUIRef." + this.cUpdateCommand
      &sMacroString.

   return

   // -------------------------------------

   function FP_Key(nChar, nPosition,bShift,bControl)
      if nChar == 13 // Enter
         this.onLeftDblClick()
      endif
   return   

   // -------------------------------------


EndClass




// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

Class CanGetRowBuilder(formObj) of CONTAINER(formObj) Custom

   /*

   CanGetRowBuilder.cc - Version 3.03.0827

   A canGetRow Filter Builder control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      width = 535 // 535
      height = 218
      borderStyle = 9	// Etched In
      metric = 6  // Pixels
      parent.metric := 6 // Pixels
   endwith

   // -------------------------------------

   // Custom properties
   this.oQR3Ref = null
   this.oTD = null
   this.aTableFieldList = null
   this.aElementLink = null

   // -------------------------------------

   this.CB_FIELD = new COMBOBOX(this)
   with (this.CB_FIELD)
      onChange = CLASS::CB_FIELD_onChange
      height = 22
      left = 10
      top = 10
      width = 156
      speedTip = "List of Field Names to Filter on"
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#110"
   endwith

   this.CB_OPERATOR = new COMBOBOX(this)
   with (this.CB_OPERATOR)
      onChange = {; this.parent.EF_COMP.setFocus()}
      height = 22
      left = 10
      top = 31
      width = 50
      dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
      speedTip = "List of Comparison operators"
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#110"
   endwith

   this.EF_CHB_BACK = new ENTRYFIELD(this)
   with (this.EF_CHB_BACK)
      height = 22
      left = 57
      top = 31
      width = 108
      colorNormal = "BtnText/BtnFace"
      value = ""
      when = {||false}
   endwith

   this.EF_COMP = new ENTRYFIELD(this)
   with (this.EF_COMP)
      height = 22
      left = 10
      top = 52
      width = 155
      value = ""
      speedTip = "Enter a value to Filter this Field on"
      helpId = "#110"
   endwith

   this.CHK_CASE = new CHECKBOX(this)
   with (this.CHK_CASE)
      height = 13
      left = 61
      top = 36
      width = 95
      text = " Match Case"
      fontSize = 9
      textLeft = true
      borderStyle = 3	// None
      speedTip = "Match case on Field Filter element"
      helpId = "#110"
   endwith

   this.RECT_FILTER_COND_BACK = new RECTANGLE(this)
   with (this.RECT_FILTER_COND_BACK)
      left = 163
      top = 10
      width = 46
      height = 64
      text = ""
      colorNormal = "WindowText/Window"
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_ADD = new PUSHBUTTON(this)
   with (this.PB_ADD)
      onClick = CLASS::Add_Element
      height = 60
      left = 165
      top = 12
      width = 43
      text = "Add"
      speedBar = true
      fontSize = 9
      speedTip = "Add this Filter Condition"
   endwith

   this.RECT_DIVIDE = new RECTANGLE(this)
   with (this.RECT_DIVIDE)
      left = 10
      top = 86
      width = 200
      height = 2
      text = ""
   endwith

   this.PB_OPENBRKT = new PUSHBUTTON(this)
   with (this.PB_OPENBRKT)
      onClick = CLASS::Add_Element
      height = 22
      left = 35
      top = 99
      width = 25
      text = "("
      speedBar = true
      speedTip = "Add an Open Bracket to the Filter"
   endwith

   this.PB_AND = new PUSHBUTTON(this)
   with (this.PB_AND)
      onClick = CLASS::Add_Element
      height = 22
      left = 60
      top = 99
      width = 50
      text = "AND"
      speedBar = true
      speedTip = "Add AND to the Filter"
   endwith

   this.PB_OR = new PUSHBUTTON(this)
   with (this.PB_OR)
      onClick = CLASS::Add_Element
      height = 22
      left = 110
      top = 99
      width = 50
      text = "OR"
      speedBar = true
      speedTip = "Add OR to the Filter"
   endwith

   this.PB_CLOSEBRKT = new PUSHBUTTON(this)
   with (this.PB_CLOSEBRKT)
      onClick = CLASS::Add_Element
      height = 22
      left = 160
      top = 99
      width = 25
      text = ")"
      speedBar = true
      speedTip = "Add an Close Bracket to the Filter"
   endwith


   this.RECT_DIVIDE2 = new RECTANGLE(this)
   with (this.RECT_DIVIDE2)
      left = 10
      top = 132
      width = 200
      height = 2
      text = ""
   endwith

   this.RECT_ADD_TEXT_BUTT_BACK = new RECTANGLE(this)
   with (this.RECT_ADD_TEXT_BUTT_BACK)
      left = 163
      top = 146
      width = 46
      height = 22
      text = ""
      colorNormal = "WindowText/Window"
      border = false
      borderStyle = 7	// Client
   endwith

   this.EF_ADD_TEXT = new ENTRYFIELD(this)
   with (this.EF_ADD_TEXT)
      height = 22
      left = 10
      top = 146
      width = 155
      maxLength = 100
      value = ""
      speedTip = "Enter a custom entry to the Filter"
   endwith

   this.PB_ADD_TEXT = new PUSHBUTTON(this)
   with (this.PB_ADD_TEXT)
      onClick = CLASS::Add_Element
      height = 19
      left = 165
      top = 148
      width = 43
      text = "Add"
      speedBar = true
      fontSize = 9
      speedTip = "Add your custom entry to the Filter"
   endwith

   this.LB_LIST = new LISTBOX(this)
   with (this.LB_LIST)
      height = 174
      left = 220
      top = 10
      width = 300
      fontSize = 9
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the tooltip to work !!
      speedTip = "Display of the elements of the Filter"
   endwith

   this.RECT_LIST_BUTT_BACK = new RECTANGLE(this)
   with (this.RECT_LIST_BUTT_BACK)
      left = 220
      top = 183
      width = 300
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_UP = new PUSHBUTTON(this)
   with (this.PB_UP)
      onClick = CLASS::MoveUp
      height = 18
      left = 222
      top = 185
      width = 74
      text = "Up"
      speedBar = true
      fontSize = 8
      speedTip = "Move the selected Element Up"
   endwith

   this.PB_DOWN = new PUSHBUTTON(this)
   with (this.PB_DOWN)
      onClick = CLASS::MoveDown
      height = 18
      left = 296
      top = 185
      width = 74
      text = "Down"
      speedBar = true
      fontSize = 8
      speedTip = "Move the selected Element Down"
   endwith

   this.PB_CLEAR_ONE = new PUSHBUTTON(this)
   with (this.PB_CLEAR_ONE)
      onClick = CLASS::RemoveOne
      height = 18
      left = 370
      top = 185
      width = 74
      text = "Clear"
      speedBar = true
      fontSize = 8
      speedTip = "Remove an Element of the Filter"
   endwith

   this.PB_CLEAR_ALL = new PUSHBUTTON(this)
   with (this.PB_CLEAR_ALL)
      onClick = CLASS::RemoveAll
      height = 18
      left = 444
      top = 185
      width = 74
      text = "Clear All"
      speedBar = true
      fontSize = 8
      speedTip = "Remove all Elements of the Filter"
   endwith

   this.TXT_FEEDBACK = new TEXT(this)
   with (this.TXT_FEEDBACK)
      onOpen = {; this.visible := false}
      height = 16
      left = 10
      top = 185
      width = 200
      colorNormal = "0xd9/BtnFace"
      alignHorizontal = 1	// Center
      transparent = true
      fontBold = true
      text = "Filter Invalid or Incomplete"
   endwith


   // -------------------------------------
                        

   function Initialise(oQR3Ref)

      // Remove existing Choices
      this.CB_FIELD.value := ""
      this.CB_FIELD.datasource = this.CB_FIELD.datasource
      this.LB_LIST.datasource := 'array {""}'

      // Give this control access to an instance of QR3
      if not empty(argvector(1))
         this.oQR3Ref = oQR3Ref
      endif

      // Create Table Definition Object
      this.oTD = new TableDef()
      this.oTD.tablename = this.oQR3Ref.TableWithPath
      this.oTD.load() 

      // create and populate FieldList array 
      // Only add fieldtypes that can be filtered on.
      // Allow Character,Numeric,Logical,Date,Float,Long,TimeStamp,Double,AutoIncrement
      // Disallow Memo,OLE,Binary & _DBASELOCK

      this.aTableFieldList = new Array()
      for nCount = 1 to this.oTD.fields.size
         if not this.oTD.fields[nCount].fieldname == "_DBASELOCK"
            if not upper(substr(this.oTD.fields[nCount].type,1,1)) $ "MOB"
               this.aTableFieldList.add(Trim(this.oTD.fields[nCount].fieldname))
            endif
         endif
      endfor // next

      // Populate Field List ListBox
      this.CB_FIELD.datasource := "Array this.aTableFieldList"
      this.CB_FIELD.value := this.aTableFieldList[1]
      
      // Ensure initial EF picture is correct
      this.CB_FIELD.onChange()

      // Initialise filter element display
      this.aElementLink = this.oQR3Ref.aCanGetRowElements
      this.LB_LIST.datasource = 'array this.aElementLink'
      this.LB_LIST.curSel = this.aElementLink.size

      // Give focus
      this.CB_FIELD.setfocus()

      // Update Filter
      this.CheckFilter()
      
      return true
          
   // -------------------------------------

      
   function SetColours(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
      endif
      if not empty(argvector(3))
      endif
      if not empty(argvector(4))
      endif
      if not empty(argvector(5))
         this.CHK_CASE.ColorNormal := cButCol
         this.PB_ADD.ColorNormal := cButCol
         this.PB_AND.ColorNormal := cButCol
         this.PB_OR.ColorNormal := cButCol
         this.PB_OPENBRKT.ColorNormal := cButCol
         this.PB_CLOSEBRKT.ColorNormal := cButCol
         this.PB_REMOVE.ColorNormal := cButCol
         this.PB_BUILD.ColorNormal := cButCol
         this.PB_CLEAR.ColorNormal := cButCol
         this.PB_SET.ColorNormal := cButCol
      endif

      return


   // -------------------------------------


   function CB_FIELD_onChange

      // shorten reference
      tp = this.parent

      // Remove existing picture for EF_COMP
      this.parent.EF_COMP.picture := null

      // Get Type of field
      cType = upper(trim(tp.oTD.fields[this.value].type))

      // Format COntrols accordingly
      do case

         case cType == 'CHARACTER' or cType == 'C'  

            nLen = tp.oTD.fields[this.value].length
            tp.EF_COMP.picture := Replicate('X',nLen)
            tp.EF_COMP.value := ''
            tp.CB_OPERATOR.dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
            tp.CHK_CASE.visible := true 

         case cType == 'DATE' or cType == 'D'

            tp.EF_COMP.value = {}
            tp.CB_OPERATOR.dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
            tp.CHK_CASE.visible := false

         case cType == 'NUMERIC' or cType == 'N' or cType == 'FLOAT'   

            // If numeric we need to format and right justify
            nLen = tp.oTD.fields[this.value].length                  
            nDec = tp.oTD.fields[this.value].decimalLength
       
            // Build format string 
       
            if nDec < 1                                                           
               cFormat = Replicate('9',nLen)                                      
            else                                                                  
               cFormat = Replicate('9',(nLen-(nDec+1)))+'.'+Replicate('9',nDec)   
            endif                                                                 
       
            // This sequence is needed to set up the EntryFields for
            // numeric entry, set the picture, and then blank the contents 
            tp.EF_COMP.value := 0
            tp.EF_COMP.picture := cFormat
            tp.EF_COMP.value := null
            tp.CB_OPERATOR.dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
            tp.CHK_CASE.visible := false

         case cType $ 'LONG,DOUBLE,AUTOINCREMENT'

            // This sequence is needed to set up the EntryFields for
            // numeric entry, set the picture, and then blank the contents
            tp.EF_COMP.value := 0
            tp.EF_COMP.picture := "999999999999999"
            tp.EF_COMP.value := null
            tp.CB_OPERATOR.dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
            tp.CHK_CASE.visible := false

         case cType == 'LOGICAL' or cType == 'L'

            tp.EF_COMP.value := true
            tp.EF_COMP.picture := "L"
            tp.EF_COMP.value := null
            tp.CB_OPERATOR.dataSource = 'array {" = "}'
            tp.CHK_CASE.visible := false
                      
         case cType == 'DATETIME'

            //tp.EF_COMP.value := null
            tp.EF_COMP.picture := "99/99/9999 99:99:99"
            tp.CB_OPERATOR.dataSource = 'array {" == "," > "," < "," >= "," <= "," <> "}'
            tp.CHK_CASE.visible := false

      endcase

      // Empty Next control
      tp.CB_OPERATOR.value := ''
       
      // Workaround for speetip bug - doesn't work after programmatic set of value.
      tp.EF_COMP.speedtip := tp.EF_COMP.speedtip 

      return


   // -------------------------------------


   function Add_Element()

      /*
      Note that the cursel cannot be updated until the datasource is re-assigned
      since the destination location may not exist in the current datasource.
      Positions should therefore be calculated relative to the initial cursel.
      */

      // shorten reference
      tp = this.parent

      // Error trap
      if this.name == "PB_ADD"
         if len(tp.CB_OPERATOR.value) < 1 or isblank(tp.EF_COMP.value)
            msgbox("Please complete all three parts first","Incomplete Filter Data",16)
            return
         endif
      endif
      if this.name == "PB_ADD_TEXT"
         if len(tp.EF_ADD_TEXT.value) < 1
            msgbox("Please enter something first","Incomplete Filter Data",16)
            return
         endif
      endif

      // Deal with empty array
      if tp.aElementLink.size == 0 
         tp.aElementLink.add('')
      endif

      // Add element to array and move entries down if required
      if not (tp.aElementLink.size == 1 and tp.aElementLink[1] == '')
         tp.aElementLink.grow(1)
         for nCount = tp.aElementLink.size to (tp.LB_List.curSel + 1) step -1
            tp.aElementLink[nCount] := '' + tp.aElementLink[nCount - 1]
         endfor // next 
         nAddPosition = tp.LB_List.curSel + 1
      else
         // Even though the cursel has been set to 0 it reports 1 so force position
         nAddPosition = 1
      endif

      // Add new element value
      do case

         case this.name == "PB_ADD"

            cType = upper(trim(tp.oTD.fields[tp.CB_FIELD.value].type))

            if cType == 'CHARACTER' or cType == 'C'

               // Add two extra elements to array and move entries down if required
               tp.aElementLink.grow(1)
               tp.aElementLink.grow(1)
               for nCount = tp.aElementLink.size to (tp.LB_List.curSel + 3) step -1
                  tp.aElementLink[nCount] = tp.aElementLink[nCount - 2]
               endfor // next 

               // Add Field
               if tp.CHK_CASE.value == true
                  tp.aElementLink[nAddPosition] = ' trim(this.fields["' + tp.CB_FIELD.value + '"].value) '
               else
                  tp.aElementLink[nAddPosition] = ' upper(trim(this.fields["' + tp.CB_FIELD.value + '"].value)) '
               endif

               // Add Operator
               nAddPosition ++
               tp.aElementLink[nAddPosition] = tp.CB_OPERATOR.value

               // Add Comparator
               nAddPosition ++
               if tp.CHK_CASE.value == true
                  tp.aElementLink[nAddPosition] = ' "' + trim(tp.EF_COMP.value) + '" '
               else
                  tp.aElementLink[nAddPosition] = ' upper("' + trim(tp.EF_COMP.value) + '") '
               endif

            endif

            if cType == 'NUMERIC' or cType == 'N' or cType == 'FLOAT' or cType == 'LONG' or cType == 'DOUBLE' or cType == 'AUTOINC'
               tp.aElementLink[nAddPosition] = ' this.fields["' + tp.CB_FIELD.value + '"].value ' + tp.CB_OPERATOR.value + " " + tp.EF_COMP.value
            endif

            if cType == 'DATE' or cType == 'D'
               tp.aElementLink[nAddPosition] = ' this.fields["' + tp.CB_FIELD.value + '"].value '  + tp.CB_OPERATOR.value + " {" + tp.EF_COMP.value + "}"
            endif

            if cType == 'LOGICAL' 
               tp.aElementLink[nAddPosition] = ' this.fields["' + tp.CB_FIELD.value + '"].value ' + tp.CB_OPERATOR.value + " " + tp.EF_COMP.value
            endif

         case this.text == "AND"

            tp.aElementLink[nAddPosition] = " AND "

         case this.text == "OR"

            tp.aElementLink[nAddPosition] = " OR "

         case this.text == "("

            tp.aElementLink[nAddPosition] = " ( "

         case this.text == ")"
                             
            tp.aElementLink[nAddPosition] = " ) "

         case this.name == "PB_ADD_TEXT"

            tp.aElementLink[nAddPosition] = tp.EF_ADD_TEXT.value

      endcase

      // Update cursel display
      /*
      Believe it or not, in order to ensure that the first element
      is displayed as selected when there is only one array element,
      the curSel must be incremented BEFORE the datasource
      is re-assigned.

      Once there is at least one existing element, the curSel must be
      incremented AFTER the datasource is re-assigned.

      Is this a dBASE bug ??? 

      No time to pursue right now

      Ronnie MacGregor
      */

      if tp.aElementLink.size = 1
         tp.LB_LIST.curSel ++
      endif

      tp.LB_LIST.datasource := "array tp.aElementLink"

      if tp.aElementLink.size > 1
         if this.name == "PB_ADD" and cType == 'CHARACTER'
            if tp.aElementLink.size == 3
               tp.LB_LIST.curSel = 1  // Must do this first !!!
               tp.LB_LIST.curSel = 3
            else
               tp.LB_LIST.curSel = tp.LB_LIST.curSel + 3
            endif
         else
            tp.LB_LIST.curSel ++
         endif
      endif

      // Update save required flag
      tp.oQR3Ref.ChangedSinceSave = true

      // Update Filter
      tp.CheckFilter()

   return
   
   // -------------------------------------


   function CheckFilter()

      // Allow referencing from both CanGetRowBuilder and it's sub controls 
      try
         x = tp
      catch ( exception e )
         tp = this
      endtry

      if not tp.aElementLink.size == 0 and not(tp.aElementLink.size == 1 and tp.aElementLink[1] == '')
         // Construct Filter
         private cCGRString
         cCGRString = 'q.rowset.canGetRow := {; bRetVal = ( '
         for nCount = 1 to tp.aElementLink.size
            cCGRString = cCGRString + tp.aElementLink[nCount]
         endfor // next
         cCGRString = cCGRString + ' ); return bRetVal}'

         // Validate Filter
         q = new query()
         q.sql := 'select * from "' + tp.oQR3Ref.TableWithPath + '"'
         q.active = true
         try
            &cCGRString.
            tp.TXT_FEEDBACK.visible := false
         catch (exception e)
            tp.TXT_FEEDBACK.visible := true
         endtry
         q.active = false
         q = null
      else
         tp.TXT_FEEDBACK.visible := false
      endif

   return

   // -------------------------------------

   function RemoveOne()

      // Remove the selected entry

      tp = this.parent
      
      // Check there are entries to remove first
      if tp.aElementLink.size < 1
         return
      endif
      
      // Get position of selected entry
      local nPosition
      nPosition = tp.LB_LIST.curSel
      
      // Delete Destination entry
      tp.aElementLink.delete(nPosition)
      
      // Re-size Destination array
      if tp.aElementLink.size = 1
         // Can't resize to 0
         // tp.aElementLink = new Array()
         // Can't do this - link is lost and tp.aElementLink becomes a local new array.
         // Instead do this :
         tp.aElementLink[1] = ''
      else
         tp.aElementLink.resize(tp.aElementLink.size - 1)
      endif
      
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      
      // Ensure appropriate entries highlighted
      if nPosition > tp.aElementLink.size
         tp.LB_LIST.curSel := nPosition - 1
      elseif tp.aElementLink.size == 1 and tp.aElementLink[1] == ''
         tp.LB_LIST.curSel := 0
      else
         tp.LB_LIST.curSel := nPosition
      endif

      // Update save required flag
      tp.oQR3Ref.ChangedSinceSave = true

      // Update Filter
      tp.CheckFilter()

   return


   // -------------------------------------


   function RemoveAll()

      // Remove all entries 

      tp = this.parent

      // Can't resize to 0
      // tp.aElementLink = new Array()
      // Can't do this - link is lost and tp.aElementLink becomes a local new array.
      // Instead do this :
      tp.aElementLink.resize(1)
      tp.aElementLink[1] = '' 
                  
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'

      // Remove highlight
      tp.LB_LIST.curSel := 0

      // Update save required flag
      tp.oQR3Ref.ChangedSinceSave = true

      // Update Filter
      tp.CheckFilter()

   return


   // -------------------------------------


   function MoveUp()

      // Move an entry up Array

      tp = this.parent

      // Check there are entries to move first      
      if tp.aElementLink.size < 2
        return
      endif
      
      local nPosition, cTemp

      nPosition = tp.LB_LIST.curSel
      
      if nPosition == 1
         return // Can't move first entry up
      endif
         
      // Do the move
      cTemp = tp.aElementLink[nPosition - 1]
      tp.aElementLink[nPosition - 1] := tp.aElementLink[nPosition]
      tp.aElementLink[nPosition] := cTemp

      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      tp.LB_LIST.curSel --

      // Update save required flag
      tp.oQR3Ref.ChangedSinceSave = true

      // Update Filter
      tp.CheckFilter()

   return


   // -------------------------------------

   
   function MoveDown()

      // Move entry down Array

      tp = this.parent
      
      // Check there are entries to move first  
      if tp.aElementLink.size = 0 
        return
      endif
        
      local nPosition, cTemp
        
      nPosition = tp.LB_LIST.curSel
        
      if nPosition == tp.aElementLink.size
         return // Can't move last entry down
      endif
      
      // Do the move
      cTemp = tp.aElementLink[nPosition + 1]
      tp.aElementLink[nPosition + 1] := tp.aElementLink[nPosition]
      tp.aElementLink[nPosition] := cTemp
      
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      tp.LB_LIST.curSel ++

      // Update save required flag
      tp.oQR3Ref.ChangedSinceSave = true

      // Update Filter
      tp.CheckFilter()
      
      return


   // -------------------------------------

EndClass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class CalcFieldBuilder(parentObj) of CONTAINER(parentObj) custom

   /*

   CalcFieldBuilder.cc - Version 3.03.0827

   A Calculated Field Builder control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      width = 435
      height = 218
      metric = 6	// Pixels
      borderStyle = 9	// Etched In
   endwith

   this.oQR3Ref = null

   // -------------------------------------

   this.CB_CALC_FIELD_LIST = new COMBOBOX(this)
   with (this.CB_CALC_FIELD_LIST)
      onChange = CLASS::CB_CALC_FIELD_LIST_onChange
      height = 22
      left = 10
      top = 10
      width = 156
      speedTip = "Select existing Calculated Field"
      fontBold = true
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#130"
   endwith

   this.RECT_NEW_BUTT_BACK = new RECTANGLE(this)
   with (this.RECT_NEW_BUTT_BACK)
      left = 164
      top = 10
      width = 46
      height = 22
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_NEW_CALC_FIELD = new PUSHBUTTON(this)
   with (this.PB_NEW_CALC_FIELD)
      onClick = {; this.parent.CONT_NEW.visible := true; this.parent.CONT_NEW.EF_NEW_NAME.setFocus()}
      height = 18
      left = 165
      top = 12
      width = 43
      text = "New"
      fontSize = 9
      speedTip = "Create a new Calculated Field"
      speedbar = true
   endwith

   //

   this.RECT_DIVIDE = new RECTANGLE(this)
   with (this.RECT_DIVIDE)
      left = 10
      top = 44
      width = 200
      height = 2
      text = ""
   endwith

   //

   this.CB_FIELD_LIST = new COMBOBOX(this)
   with (this.CB_FIELD_LIST)
      height = 22
      left = 10
      top = 58
      width = 156
      speedTip = "List of Field Names to add to Calculated Field"
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#130"
   endwith

   this.RECT_ADD_FIELD = new RECTANGLE(this)
   with (this.RECT_ADD_FIELD)
      left = 163
      top = 58
      width = 46
      height = 22
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_ADD_FIELD = new PUSHBUTTON(this)
   with (this.PB_ADD_FIELD)
      onClick = {; this.parent.AddElement(this.parent.CB_FIELD_LIST.value) }
      height = 18
      left = 165
      top = 60
      width = 43
      text = "Add"
      fontSize = 9
      speedTip = "Add Field Name to Calculated Field"
      speedbar = true
   endwith

   this.PB_SPACE = new PUSHBUTTON(this)
   with (this.PB_SPACE)
      onClick = {; this.parent.AddElement([ + " " + ]) }
      height = 20
      left = 10
      top = 93
      width = 60
      text = "Space"
      fontSize = 9
      speedTip = "Add a Space to the Calculated Field"
      speedbar = true
   endwith

   this.PB_LINE_BREAK = new PUSHBUTTON(this)
   with (this.PB_LINE_BREAK)
      onClick = {; this.parent.AddElement([ + " <BR> " + ]); this.parent.oQR3Ref.aaColumnWrap[this.parent.CB_CALC_FIELD_LIST.value] = true }
      height = 20
      left = 70
      top = 93
      width = 80
      text = "Line Break"
      fontSize = 9
      speedTip = "Add a Line Break to the Calculated Field"
      speedbar = true
   endwith

   this.PB_COMMA = new PUSHBUTTON(this)
   with (this.PB_COMMA)
      onClick = {; this.parent.AddElement([ + ", " + ]) }
      height = 20
      left = 150
      top = 93
      width = 60
      text = "Comma"
      fontSize = 9
      speedTip = "Add a Comma to the Calculated Field"
      speedbar = true
   endwith

   this.PB_OPENBRKT = new PUSHBUTTON(this)
   with (this.PB_OPENBRKT)
      onClick = {; this.parent.AddElement(" ( ") }
      height = 27
      left = 35
      top = 124
      width = 25
      text = "("
      speedTip = "Add an Open Bracket to the Calculated Field"
      speedbar = true
   endwith

   this.PB_PLUS = new PUSHBUTTON(this)
   with (this.PB_PLUS)
      onClick = {; this.parent.AddElement(" + ") }
      height = 27
      left = 60
      top = 124
      width = 25
      text = "+"
      speedTip = "Add the Addition Operator to the Calculated Field"
      speedbar = true
   endwith

   this.PB_MINUS = new PUSHBUTTON(this)
   with (this.PB_MINUS)
      onClick = {; this.parent.AddElement(" - ") }
      height = 27
      left = 85
      top = 124
      width = 25
      text = "-"
      speedTip = "Add the Subtraction Operator to the Calculated Field"
      speedbar = true
   endwith

   this.PB_MULTIPLY = new PUSHBUTTON(this)
   with (this.PB_MULTIPLY)
      onClick = {; this.parent.AddElement(" * ") }
      height = 27
      left = 110
      top = 124
      width = 25
      text = "x"
      speedTip = "Add the Multiplication Operator to the Calculated Field"
      speedbar = true
   endwith

   this.PB_DIVIDE = new PUSHBUTTON(this)
   with (this.PB_DIVIDE)
      onClick = {; this.parent.AddElement(" / ") }
      height = 27
      left = 135
      top = 124
      width = 25
      text = "/"
      speedTip = "Add the Division Operator to the Calculated Field"
      speedbar = true
   endwith

   this.PB_CLOSEBRKT = new PUSHBUTTON(this)
   with (this.PB_CLOSEBRKT)
      onClick = {; this.parent.AddElement(" ) ") }
      height = 27
      left = 160
      top = 124
      width = 25
      text = ")"
      speedTip = "Add an Close Bracket to the Calculated Field"
      speedbar = true
   endwith

   this.EF_ADD_TEXT = new ENTRYFIELD(this)
   with (this.EF_ADD_TEXT)
      height = 22
      left = 10
      top = 163
      width = 155
      value = ""
      speedTip = "Type in anything you wish to add to the calculated field"
      helpId = "#130"
   endwith

   this.RECT_ADD_TEXT = new RECTANGLE(this)
   with (this.RECT_ADD_TEXT)
      left = 163
      top = 163
      width = 46
      height = 22
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_ADD_TEXT = new PUSHBUTTON(this)
   with (this.PB_ADD_TEXT)
      onClick = {; this.parent.AddElement(this.parent.EF_ADD_TEXT.value); this.parent.EF_ADD_TEXT.value := '' }
      height = 19
      left = 165
      top = 165
      width = 43
      text = "Add"
      fontSize = 9
      speedTip = "Add Entered Text to Calculated Field"
      speedbar = true
   endwith

   //

   this.LB_LIST = new LISTBOX(this)
   with (this.LB_LIST)
      height = 174
      left = 220
      top = 10
      width = 200
      dataSource = 'ARRAY {""}' // Must assign on instantiation for the tooltip to work !!
      speedTip = "Display of the elements of the Calculated Field"
      multiple = false
      cursel = 0
      helpId = "#130"
   endwith

   this.RECT_LIST_BUTT_BACK = new RECTANGLE(this)
   with (this.RECT_LIST_BUTT_BACK)
      left = 220
      top = 183
      width = 200
      height = 21
      text = ""
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_UP = new PUSHBUTTON(this)
   with (this.PB_UP)
      onClick = CLASS::MoveUp
      height = 18
      left = 222
      top = 185
      width = 49
      text = "Up"
      fontSize = 8
      speedTip = "Move the selected Element Up"
      speedbar = true
   endwith

   this.PB_DOWN = new PUSHBUTTON(this)
   with (this.PB_DOWN)
      onClick = CLASS::MoveDown
      height = 18
      left = 271
      top = 185
      width = 49
      text = "Down"
      fontSize = 8
      speedTip = "Move the selected Element Down"
      speedbar = true
   endwith

   this.PB_CLEAR_ONE = new PUSHBUTTON(this)
   with (this.PB_CLEAR_ONE)
      onClick = CLASS::RemoveOne
      height = 18
      left = 320
      top = 185
      width = 49
      text = "Clear"
      fontSize = 8
      speedTip = "Remove an Element of the Calculated Field"
      speedbar = true
   endwith

   this.PB_CLEAR_ALL = new PUSHBUTTON(this)
   with (this.PB_CLEAR_ALL)
      onClick = CLASS::RemoveAll
      height = 18
      left = 369
      top = 185
      width = 49
      text = "Clear All"
      fontSize = 8
      speedTip = "Remove all Elements of the Calculated Field"
      speedbar = true
   endwith

   //

   this.CONT_NEW = new CONTAINER(this)
   with (this.CONT_NEW)
      visible = false
      left = 102
      top = 40
      width = 230
      height = 140
      borderStyle = 8	// Modal
   endwith

   this.CONT_NEW.TL_NEW_NAME = new TEXTLABEL(this.CONT_NEW)
   with (this.CONT_NEW.TL_NEW_NAME)
      height = 22
      left = 10
      top = 10
      width = 60
      text = "Name"
      alignVertical = 1	// Middle
   endwith

   this.CONT_NEW.EF_NEW_NAME = new ENTRYFIELD(this.CONT_NEW)
   with (this.CONT_NEW.EF_NEW_NAME)
      height = 22
      left = 80
      top = 10
      width = 135
      speedTip = "Enter the name for a new Calculated Field"
      value = ""
      helpId = "#130"
   endwith

   this.CONT_NEW.TL_NEW_TYPE = new TEXTLABEL(this.CONT_NEW)
   with (this.CONT_NEW.TL_NEW_TYPE)
      height = 22
      left = 10
      top = 40
      width = 60
      text = "Type"
      alignVertical = 1	// Middle
   endwith

   this.CONT_NEW.CB_NEW_TYPE = new COMBOBOX(this.CONT_NEW)
   with (this.CONT_NEW.CB_NEW_TYPE)
      onChange = {;this.parent.SB_LENGTH.value := iif(this.value=="Character",25,iif(this.value=="Numeric",5,10))}
      height = 22
      left = 80
      top = 40
      width = 135
      dataSource = 'array {"Character","Numeric","Date"}'
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#130"
   endwith

   this.CONT_NEW.TL_NEW_LENGTH = new TEXTLABEL(this.CONT_NEW)
   with (this.CONT_NEW.TL_NEW_LENGTH)
      height = 22
      left = 10
      top = 70
      width = 60
      text = "Length"
      alignVertical = 1	// Middle
   endwith

   this.CONT_NEW.SB_LENGTH = new SPINBOX(this.CONT_NEW)
   with (this.CONT_NEW.SB_LENGTH)
      onChange = {;if this.parent.CB_NEW_TYPE.value=="Date" ; this.value := 10; endif}
      height = 22
      left = 80
      top = 70
      width = 56
      rangeMax = 100
      rangeMin = 1
      value = 25
      validRequired = true
      rangeRequired = true
      helpId = "#130"
   endwith

   this.CONT_NEW.PB_NEW_CANCEL = new PUSHBUTTON(this.CONT_NEW)
   with (this.CONT_NEW.PB_NEW_CANCEL)
      onClick = {; this.parent.visible := false}
      height = 21
      left = 105
      top = 101
      width = 50
      text = "Cancel"
      fontSize = 9
   endwith

   this.CONT_NEW.PB_NEW_OK = new PUSHBUTTON(this.CONT_NEW)
   with (this.CONT_NEW.PB_NEW_OK)
      onClick = {; this.parent.parent.NewCalcField(); this.parent.visible := false}
      height = 21
      left = 165
      top = 101
      width = 50
      text = "OK"
      fontSize = 9
   endwith


   // -------------------------------------


   function Initialise(oQR3Ref)

      // Remove existing Calc Field Choice
      this.CB_CALC_FIELD_LIST.value := ""
      this.CB_FIELD_LIST.value := ""
      this.CB_FIELD_LIST.datasource = this.CB_FIELD_LIST.datasource
      this.LB_LIST.datasource := 'array {""}'

      // Give this control access to an instance of QR3
      if not empty(argvector(1))
         this.oQR3Ref = oQR3Ref
      endif

      // Build Array of existing calculated field names
      this.aCalcFieldList = new Array()
      for nCount = 1 to this.oQR3Ref.aaCalcFields.count()
         if nCount = 1
            cCurrKey = this.oQR3Ref.aaCalcFields.firstKey
         else
            cCurrKey = this.oQR3Ref.aaCalcFields.nextKey(cCurrKey)
         endif
         this.aCalcFieldList.add(cCurrKey)
      endfor // next
      this.aCalcFieldList.sort()
      this.CB_CALC_FIELD_LIST.datasource := "Array this.aCalcFieldList"

      // Build Table Field List - Less any Calculated Fields
      this.aTableFieldList = new Array()
      for nCount = 1 to this.oQR3Ref.aTableFieldList.size
         cFieldName = this.oQR3Ref.aTableFieldList[nCount]
         if this.oQR3Ref.aaCalcFields.isKey(cFieldName)
            // do nothing it's a calculated field
         elseif this.oQR3Ref.aaMemoTextFields.isKey(cFieldName)
            // do nothing it's a MemoText field
         else
            this.aTableFieldList.add(cFieldName)
         endif
      endfor // next
      this.CB_FIELD_LIST.datasource := "Array this.aTableFieldList"

      // Set to new field if appropriate
      if len(this.CONT_NEW.EF_NEW_NAME.value) > 0
         this.CB_CALC_FIELD_LIST.value = this.CONT_NEW.EF_NEW_NAME.value
      endif

      // Set follow on controls
      this.CB_CALC_FIELD_LIST.onChange()

      // Initialise New Entryfield
      this.CONT_NEW.EF_NEW_NAME.value = ''

   return

   // -------------------------------------

   function SetColours(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         this.CB_CALC_FIELD_LIST.ColorNormal := cListCol
         this.CB_FIELD_LIST.ColorNormal := cListCol
         this.LB_LIST.ColorNormal := cListCol
      endif
      if not empty(argvector(3))
         this.LB_LIST.ColorHighlight := cListHigh
      endif
      if not empty(argvector(4))
      endif
      if not empty(argvector(3))
         this.PB_SPACE.ColorNormal := cButCol
         this.PB_BREAK.ColorNormal := cButCol
         this.PB_COMMA.ColorNormal := cButCol
         this.PB_OPENBRKT.ColorNormal := cButCol
         this.PB_PLUS.ColorNormal := cButCol
         this.PB_MINUS.ColorNormal := cButCol
         this.PB_MULTIPLY.ColorNormal := cButCol
         this.PB_DIVIDE.ColorNormal := cButCol
         this.PB_CLOSEBRKT.ColorNormal := cButCol
      endif      
      
      return

   // -------------------------------------


   function NewCalcField()

      // Validate user entries first
      if len(this.CONT_NEW.EF_NEW_NAME.value) < 1
         msgbox("No Name Entered","Missing Information",0+48)
         return
      endif
      if len(this.CONT_NEW.CB_NEW_TYPE.value) < 1
         msgbox("No Field Type Selected","Missing Information",0+48)
         return
      endif
      if this.CONT_NEW.SB_LENGTH.value < 1
         msgbox("No Field Length Set","Missing Information",0+48)
         return
      endif

      // Create new Calc Field
      lRet = this.oQR3Ref.CreateCalcField(this.CONT_NEW.EF_NEW_NAME.value,;
                substr(this.CONT_NEW.CB_NEW_TYPE.value,1,1),;
                this.CONT_NEW.SB_LENGTH.value)

      if lRet == false
         return
      endif

      // Re-initialise CalcFieldBuilder
      this.Initialise()

      // Give Focus
      this.CB_CALC_FIELD_LIST.setFocus()
      
   return

   // -------------------------------------

   function CB_CALC_FIELD_LIST_onChange()

      tp = this.parent

      if len(this.value) > 0
         tp.aElementLink = tp.oQR3Ref.aaCalcFields[this.value]
         tp.LB_LIST.datasource = 'array tp.aElementLink'
         // Arrange for view of end of selection
         tp.LB_LIST.curSel = tp.aElementLink.size
         if tp.aElementLink.size > 9
            tp.LB_LIST.curSel := tp.aElementLink.size - 8
         else
            tp.LB_LIST.curSel := 1
         endif
         tp.LB_LIST.curSel := tp.aElementLink.size
      else
         tp.LB_LIST.curSel := 0
      endif

   return
                                           
   // -------------------------------------

   function AddElement(cElement)

      if len(trim(this.CB_CALC_FIELD_LIST.value)) > 0

         // Add element
         if this.aElementLink.size == 1 and this.aElementLink[1] == ''
            this.aElementLink[1] = cElement
         else 
            this.aElementLink.add(cElement)
         endif

         // Update Element List Display
         this.LB_LIST.datasource = 'array this.aElementLink'
         this.LB_LIST.curSel = this.aElementLink.size

      else

         msgbox("No Calculated Field selected","User error",0+16)

      endif

   return

   // -------------------------------------


   function RemoveOne

      // Remove the selected entry

      tp = this.parent
      
      // Check there are entries to remove first
      if tp.aElementLink.size < 1
         return
      endif
      
      // Get position of selected entry
      local nPosition
      nPosition = tp.LB_LIST.curSel
      
      // Delete Destination entry
      tp.aElementLink.delete(nPosition)
      
      // Re-size Destination array
      if tp.aElementLink.size = 1
         // Can't resize to 0
         //tp.aElementLink = new Array() // Can't do this - link is lost and tp.aElementLink becomes a local new array.
         tp.aElementLink[1] = '' // Instead do this
      else
         tp.aElementLink.resize(tp.aElementLink.size - 1)
      endif
      
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      
      // Ensure appropriate entries highlighted
      if nPosition > tp.aElementLink.size
         tp.LB_LIST.curSel := nPosition - 1
      else
         tp.LB_LIST.curSel := nPosition
      endif

   return


   // -------------------------------------


   function RemoveAll

      // Remove all entries 

      tp = this.parent

      // Can't resize to 0
      //tp.aElementLink = new Array() // Can't do this - link is lost and tp.aElementLink becomes a local new array.
      // Instead do this:
      tp.aElementLink.resize(1)
      tp.aElementLink[1] = '' 
                  
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      
      // Remove highlight
      tp.LB_LIST.curSel := 1
      tp.LB_LIST.curSel := 0

   return


   // -------------------------------------


   function MoveUp

      // Move an entry up Array

      tp = this.parent

      // Check there are entries to move first      
      if tp.aElementLink.size < 2
        return
      endif
      
      local nPosition, cTemp

      nPosition = tp.LB_LIST.curSel
      
      if nPosition == 1
         return // Can't move first entry up
      endif
         
      // Do the move
      cTemp = tp.aElementLink[nPosition - 1]
      tp.aElementLink[nPosition - 1] := tp.aElementLink[nPosition]
      tp.aElementLink[nPosition] := cTemp

      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      tp.LB_LIST.curSel --

   return


   // -------------------------------------

   
   function MoveDown()

      // Move entry down Array

      tp = this.parent
      
      // Check there are entries to move first  
      if tp.aElementLink.size = 0 
        return
      endif
        
      local nPosition, cTemp
        
      nPosition = tp.LB_LIST.curSel
        
      if nPosition == tp.aElementLink.size
         return // Can't move last entry down
      endif
      
      // Do the move
      cTemp = tp.aElementLink[nPosition + 1]
      tp.aElementLink[nPosition + 1] := tp.aElementLink[nPosition]
      tp.aElementLink[nPosition] := cTemp
      
      // Update Listbox display
      tp.LB_LIST.dataSource := 'array tp.aElementLink'
      tp.LB_LIST.curSel ++
      
      return


   // -------------------------------------


endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class MemoTextFieldBuilder(parentObj) of CONTAINER(parentObj) custom

   /*

   MemoTextFieldBuilder.cc - Version 3.03.0827

   A MemoText Field Builder control for Quick Reports 3


   For         :    dBASE Plus / dB2K / Win9x / Win2000



   Author      :  Ronnie MacGregor

   Contact     :  QR3Feedback@high-lugtonridge.co.uk

   Copyright   :  Ronnie MacGregor   All rights reserved.

   Disclaimer  :  It is the duty of the user of this code to determine it's 
                  suitability for use.

                  The use of this code signifies agreement to the following
                  condition of use.
                  
                  In no circumstance will the author accept any responsibility
                  for any consequence arising from the use of this code.

   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels

   with (this)
      left = 6
      top = 33
      width = 244
      height = 190
      metric = 6	// Pixels
      borderStyle = 9	// Etched In
   endwith

   this.oQR3Ref = null

   // -------------------------------------

   this.TL_MT_DATA_TABLE = new TEXTLABEL(this)
   with (this.TL_MT_DATA_TABLE)
      height = 22
      left = 10
      top = 7
      width = 220
      text = "MemoText Data Table"
      transparent = true
   endwith

   this.CB_MT_DATA_TABLE = new COMBOBOX(this)
   with (this.CB_MT_DATA_TABLE)
      onChange = {; this.parent.oQR3Ref.MemoTextTable := this.value}
      height = 22
      left = 10
      top = 29
      width = 220
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#140"
   endwith

   this.RECT_DIVIDE = new RECTANGLE(this)
   with (this.RECT_DIVIDE)
      left = 10
      top = 62
      width = 220
      height = 2
      text = ""
   endwith

   this.TL_MEMOTEXT_FIELD = new TEXTLABEL(this)
   with (this.TL_MEMOTEXT_FIELD)
      height = 22
      left = 10
      top = 71
      width = 220
      text = "MemoText Field"
      transparent = true
   endwith

   this.CB_FIELD_LIST = new COMBOBOX(this)
   with (this.CB_FIELD_LIST)
      onChange = CLASS::CB_FIELD_LIST_onChange
      height = 22
      left = 10
      top = 94
      width = 176
      speedTip = "Select existing MemoText Field"
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#140"
   endwith

   this.RECT_NEW_BUTT_BACK = new RECTANGLE(this)
   with (this.RECT_NEW_BUTT_BACK)
      left = 184
      top = 94
      width = 46
      height = 22
      text = ""
      colorNormal = "WindowText/Window"
      border = false
      borderStyle = 7	// Client
   endwith

   this.PB_NEW_FIELD = new PUSHBUTTON(this)
   with (this.PB_NEW_FIELD)
      onClick = {; this.parent.CONT_NEW.visible := true; this.parent.CONT_NEW.EF_NEW_NAME.setFocus()}
      height = 18
      left = 185
      top = 96
      width = 43
      text = "New"
      fontSize = 9
      speedTip = "Create a new MemoText Field"
   endwith

   this.TL_LINK_FIELD = new TEXTLABEL(this)
   with (this.TL_LINK_FIELD)
      height = 22
      left = 10
      top = 127
      width = 220
      text = "Link Field in Report Table"
      transparent = true
   endwith

   this.CB_LINK_FIELD = new COMBOBOX(this)
   with (this.CB_LINK_FIELD)
      onChange = {; this.parent.oQR3Ref.aaMemoTextFields[this.parent.CB_FIELD_LIST.value] := this.value}
      height = 22
      left = 10
      top = 151
      width = 220
      style = 2	// DropDownList
      dropDownHeight = 132
      helpId = "#140"
   endwith

   this.CONT_NEW = new CONTAINER(this)
   with (this.CONT_NEW)
      visible = false
      left = 7
      top = 42
      width = 230
      height = 106
      borderStyle = 8	// Modal
   endwith

   this.CONT_NEW.TL_NEW_NAME = new TEXTLABEL(this.CONT_NEW)
   with (this.CONT_NEW.TL_NEW_NAME)
      height = 22
      left = 10
      top = 12
      width = 60
      text = "Name"
      alignVertical = 1	// Middle
   endwith

   this.CONT_NEW.EF_NEW_NAME = new ENTRYFIELD(this.CONT_NEW)
   with (this.CONT_NEW.EF_NEW_NAME)
      height = 22
      left = 80
      top = 12
      width = 135
      speedTip = "Enter the name for a new Calculated Field"
      value = ""
      helpId = "#140"
   endwith

   this.CONT_NEW.TL_NEW_LENGTH = new TEXTLABEL(this.CONT_NEW)
   with (this.CONT_NEW.TL_NEW_LENGTH)
      height = 22
      left = 10
      top = 42
      width = 60
      text = "Length"
      alignVertical = 1	// Middle
   endwith

   this.CONT_NEW.SB_LENGTH = new SPINBOX(this.CONT_NEW)
   with (this.CONT_NEW.SB_LENGTH)
      height = 22
      left = 80
      top = 42
      width = 56
      rangeMax = 100
      rangeMin = 1
      value = 50
      validRequired = true
      rangeRequired = true
      helpId = "#140"
   endwith

   this.CONT_NEW.PB_NEW_CANCEL = new PUSHBUTTON(this.CONT_NEW)
   with (this.CONT_NEW.PB_NEW_CANCEL)
      onClick = {; this.parent.visible := false}
      height = 21
      left = 105
      top = 73
      width = 50
      text = "Cancel"
      fontSize = 9
   endwith

   this.CONT_NEW.PB_NEW_OK = new PUSHBUTTON(this.CONT_NEW)
   with (this.CONT_NEW.PB_NEW_OK)
      onClick = {; this.parent.parent.NewMTField(); this.parent.visible := false}
      height = 21
      left = 165
      top = 73
      width = 50
      text = "OK"
      fontSize = 9
   endwith

   // -------------------------------------

   function Initialise_MTFB(oQR3Ref)

      // Remove existing Choices
      this.CB_MT_DATA_TABLE.value := ""
      this.CB_FIELD_LIST.value := ""
      this.CB_LINK_FIELD.value := ""

      // Give this control access to an instance of QR3
      if not empty(argvector(1))
         this.oQR3Ref = oQR3Ref
      endif

      // Set up the MemoText Data Table
      this.CB_MT_DATA_TABLE.DataSource := "array this.oQR3Ref.aTableList"
      this.CB_MT_DATA_TABLE.value := this.oQR3Ref.MemoTextTable

      // Build Array of existing MemoText field names
      this.aMTFieldList = new Array()
      for nCount = 1 to this.oQR3Ref.aaMemoTextFields.count()
         if nCount = 1
            cCurrKey = this.oQR3Ref.aaMemoTextFields.firstKey
         else
            cCurrKey = this.oQR3Ref.aaMemoTextFields.nextKey(cCurrKey)
         endif
         this.aMTFieldList.add(cCurrKey)
      endfor // next
      this.aMTFieldList.sort()
      this.CB_FIELD_LIST.datasource := "Array this.aMTFieldList"

      // Build List of available Link Fields
      this.aTableFieldList = new Array()
      for nCount = 1 to this.oQR3Ref.aTableFieldList.size
         cFieldName = this.oQR3Ref.aTableFieldList[nCount]
         if this.oQR3Ref.aaCalcFields.isKey(cFieldName)
            // do nothing it's a calculated field
         elseif this.oQR3Ref.aaMemoTextFields.isKey(cFieldName)
            // do nothing it's a MemoText field
         else
            this.aTableFieldList.add(cFieldName)
         endif
      endfor // next
      this.CB_LINK_FIELD.datasource := "Array this.aTableFieldList"

      // Set to new field if appropriate
      if len(this.CONT_NEW.EF_NEW_NAME.value) > 0
         this.CB_FIELD_LIST.value = this.CONT_NEW.EF_NEW_NAME.value
      endif

      // Set follow on controls
      this.CB_FIELD_LIST.onChange()  

      // Initialise New Entryfield
      this.CONT_NEW.EF_NEW_NAME.value = ''

   return

   // -------------------------------------

   function SetColours(cBackCol, cListCol, cListHigh, cTextCol, cButCol)

      if not empty(argvector(1))
         this.ColorNormal := cBackCol
      endif
      if not empty(argvector(2))
         this.CB_MT_DATA_TABLE.ColorNormal := cListCol
         this.CB_FIELD_LIST.ColorNormal := cListCol
         this.CB_LINK_FIELD.ColorNormal := cListCol
      endif
      if not empty(argvector(3))
      endif
      if not empty(argvector(4))
         this.TL_MT_DATA_TABLE.ColorNormal := cTextCol
         this.TL_MEMOTEXT_FIELD.ColorNormal := cTextCol
         this.TL_LINK_FIELD.ColorNormal := cTextCol
      endif
      if not empty(argvector(3))
      endif      
      
      return

   // -------------------------------------

   function CB_FIELD_LIST_onChange()

      tp = this.parent

      if len(this.value) > 0
         tp.CB_LINK_FIELD.value := tp.oQR3Ref.aaMemoTextFields[this.value]
      else
         tp.CB_LINK_FIELD.value := ""
      endif

   return

   // -------------------------------------

   function NewMTField()

      // Validate user entries first
      if len(this.CONT_NEW.EF_NEW_NAME.value) < 1
         msgbox("No Name Entered","Missing Information",0+48)
         return
      endif
      if this.CONT_NEW.SB_LENGTH.value < 1
         msgbox("No Field Length Set","Missing Information",0+48)
         return
      endif

      // Create new MemoText Field
      lRet = this.oQR3Ref.CreateMemoTextField(this.CONT_NEW.EF_NEW_NAME.value,;
                                       this.CONT_NEW.SB_LENGTH.value)

      if lRet == false
         return
      endif

      // Re-initialise CalcFieldBuilder
      this.Initialise_MTFB()

      // Give Focus
      this.CB_FIELD_LIST.setFocus()
      
   return

   // -------------------------------------

endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

class NudgeCombo(parentObj) of COMBOBOX(parentObj) custom

   /*

	Filename:   NudgeCombo.cc
   Version:    1.20 
   Date:       2002 10 30

   For:        dBASE PLUS / dB2K / Visual dBase 7.** 
               Windows 95/98/ME/XP/NT/2000

   Author:     Ronnie MacGregor
   Contact:    NudgeComboFeedBack@high-lugtonridge.co.uk
	
   
   Description:

      A "style = 2 // DropDownList" Combobox with nudge buttons
      which allow a single click nudge to the next entry in 
      the list, either up or down, without dropping the box.

      The control prevents doubleClicks onGotFocus and restores
      them onLostFocus. This means that rapid clicking of the nudge
      buttons produces a stream of single click events, and therefore
      the expected number of nudges.


   Revisions:

      2003 02 12  Version 1.10
      ========================

      Macro instantiation of Nudge Buttons dropped in favour of
      creating them as a property of the ComboBox while still using
      the form as the container. Slightly simpler, and slightly
      faster to open.

      2003 02 14  version 1.10 (dUFLP)
      ================================

      Modified to use :duflp: source code alias for bitmap
      images (up.bmp and down.bmp). - Ken Mayer

      2003 03 12  Version 1.20
      ========================

      SetDataSource can now handle being passed an array object ref,
      a literal array or a literal array passed as a string.

      OnDesignOpen added to improve appearance in the form designer.

      NudgeButtons now assigned the pageno of the control.

      NudgeButton logic changed to cope with zero datasource elements.

      Code added to ensure that the nudge buttons don't remain showing
      on form.pageNo 1 where they are instantiated prior to the setting
      of their page number, when the parent control is on another page.


   Methods:

      SetDataSource()

         This method must be used if you wish to re-assign the
         control's DataSource after the control is open. This is
         required to set up an array of the combobox contents for the
         nudge buttons to use.

         Literal array example:

            form.NCB_01.SetDataSource({"Item 1","Item 2","Item 3"})

         Array object reference example

            form.NCB_01.SetDataSource(aMyArray)

         Literal array passed as string example:

            form.NCB_01.SetDataSource('{"Item 1","Item 2","Item 3"}')


   Dependancies:

      Up.bmp and Down.bmp

      These tiny bitmaps are required for the nudge buttons, but
      the control has been coded to function error free if they
      are not found.

      This version in QR3Controls.cc gets these bitmaps from QR3Res.dll      

   Acknowledgements:

      Some elements of the Nudge Button instantiation method derived
      from an unrelated sample by Marko Mihorko. 
         
   */

   // Ensure control drops onto form correctly
   form.metric := 6 // Pixels


   // Set Up LockWindow capability
   if type("LockWindowUpdate") # "FP"
      extern cLogical LockWindowUpdate( cHandle ) user32
   endif
   if type("GetDesktopWindow") # "FP"
      extern cHandle GetDesktopWindow( cVoid ) user32
   endif   

   // Set up NoDoubleClick capability
   #ifndef UINT
      #define UINT  CUINT
   #endif
   #ifndef VOID
      #define VOID  CVOID
   #endif
   #ifndef BOOL
      #define BOOL  CLOGICAL
   #endif

   if type( "GetDoubleClickTime" ) # "FP"
      extern UINT GetDoubleClickTime(VOID) user32
   endif
   if type( "SetDoubleClickTime" ) # "FP"
      extern BOOL SetDoubleClickTime(UINT) user32
   endif
     
   // Store the system doubleCLick time
   this.OldDoubleClickTime = GetDoubleClickTime()


   // Standard and default properties
   with (this)
      onOpen = CLASS::onOpen
      onDesignOpen = CLASS::onOpen
      onGotFocus = {; SetDoubleClickTime(10)}
      onLostFocus = {; SetDoubleClickTime(this.OldDoubleClickTime)}
      canClose = CLASS::canClose
      width = 220
      height = 22
      dataSource = 'array {"Default DataSource 1","Default DataSource 2","Default DataSource 3","Default DataSource 4","Default DataSource 5"}'
      style = 2	// DropDownList
      dropDownHeight = 132
   endwith
   
   //----------------------------------------   

   function onOpen()

      // Lock Window
      LockWindowUpdate( GetDesktopWindow() )

      // Create Nudge Up Button
      this.PB_Nudge_Up = new NudgeButton(this.parent)
      with (this.PB_Nudge_Up)
         top = this.top + 2
         left = this.left + this.width - 34
         width = 16
         height = int((this.height - 4)/2)
         pageno = this.pageno
         if file('up.bmp',true)
            upBitmap := "filename Up.bmp"
         else
            try
               upBitmap := "resource #9003 QR3Res.dll"
            catch( Exception E )
               upBitmap := null
            endtry
         endif
      endwith
      // Give NudgeButton a reference to this control
      this.PB_Nudge_Up.Owner = this
      // Set Nudge Direction
      this.PB_Nudge_Up.Direction = 'up'

      // Create Nudge Down Button
      this.PB_Nudge_Down = new NudgeButton(this.parent)
      with (this.PB_Nudge_Down)
         top = this.top + int(this.height / 2)
         left = this.left + this.width - 34
         width = 16
         height = int( (this.height - 4) / 2)
         pageno = this.pageno
         if file('down.bmp',true)
            upBitmap := "filename down.bmp"
         else
            try
               upBitmap := "resource #9004 QR3Res.dll"
            catch( Exception E )
               upBitmap := null
            endtry
         endif
      endwith
      // Give NudgeButton a reference to this control
      this.PB_Nudge_Down.Owner = this
      // Set Nudge Direction
      this.PB_Nudge_Down.Direction = 'down'
      // Deal with odd numbered control heights
      if not ((this.PB_Nudge_Down.height * 2) + 4) == this.height
         this.PB_Nudge_Down.height ++ 
      endif

      // Initialise Nudge array
      this.SetDataSource()

      // Change page and back to ensure nudgebuttons don't still show
      // on page 1 when the control is on another form page.
      n = form.pageNo
      form.pageNo := n + 1
      form.pageNo := n    

      // Unlock Window
      LockWindowUpdate(0) 

   return

   //----------------------------------------

   function SetDataSource 

      parameters ds 

      // Check we are not in the form designer
      if form.inDesign == true
         // leave default dataSource intact
         return
      endif

      // Create array of ComboBox contents
      if empty(argvector(1))
         // Build Nudge Array with existing datasource
         if "ARRAY" $ upper(this.dataSource)
            private c
            c = this.dataSource
            c = substr(c,at("ARRAY",upper(c),1)+6)
            this.aList = &c.
         else
            // this.dataSource not defined
            this.aList = new array()
         endif
      else
         if type("ds") == "C"
            // Literal array passed as string
            this.aList = &ds.
         else
            // Literal array or array object reference
            this.aList = ds
         endif
      endif

      // Clear existing NudgeCombo value
      this.value = ""

      // Assign new DataSource
      this.DataSource := "array this.aList"

   return

   //----------------------------------------

   function canClose
      // Remove circular references
      this.PB_Nudge_Up.Owner := null
      this.PB_Nudge_Down.Owner := null
   return true

   //----------------------------------------

endclass

/////////////////////////////////////////////////////////

class NudgeButton(parentObj) of PUSHBUTTON(parentObj) custom

   with (this)
      onClick = CLASS::Nudge
      top = 0
      left = 0
      width = 16
      height = 10
      text = ""
      speedbar = true
   endwith

   //----------------------------------------

   function Nudge()

      // Shorten reference
      to = this.Owner

      // Ensure the NudgeCombo control has focus
      to.setFocus()

      // Find Current value position
      nPos = to.aList.scan(to.value)

      // Select new value
      do case

         case this.direction == "up"
            if nPos > 1
               to.value = to.aList[nPos-1]
            endif

         case this.direction == "down"
            if nPos < to.aList.size
               to.value = to.aList[nPos+1]
            endif
       
      endcase
      
      // If the control has an onChange event, fire it
      try
         to.onChange()
      catch ( Exception e )
         // do nothing - onChange event doesn't exist
      endtry
            
   return

   //----------------------------------------

endclass

// -------------------------------------------------------------------
// -------------------------------------------------------------------
// -------------------------------------------------------------------

// EOF